View Javadoc

    1   //========================================================================
    2   //$Id: ThreadPool.java,v 1.4 2005/11/20 11:30:38 gregwilkins Exp $
    3   //Copyright 2004-2005 Mort Bay Consulting Pty. Ltd.
    4   //------------------------------------------------------------------------
    5   //Licensed under the Apache License, Version 2.0 (the "License");
    6   //you may not use this file except in compliance with the License.
    7   //You may obtain a copy of the License at
    8   //http://www.apache.org/licenses/LICENSE-2.0
    9   //Unless required by applicable law or agreed to in writing, software
    10  //distributed under the License is distributed on an "AS IS" BASIS,
    11  //WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    12  //See the License for the specific language governing permissions and
    13  //limitations under the License.
    14  //========================================================================
    15
    16  package org.mortbay.thread;
    17
    18  import org.mortbay.component.LifeCycle;
    19
    20  /* ------------------------------------------------------------ */
    21  /** ThreadPool.
    22   * @author gregw
    23   *
    24   */
    25  public interface ThreadPool
    26  {
    27      /* ------------------------------------------------------------ */
    28      public abstract boolean dispatch(Runnable job);
    29
    30      /* ------------------------------------------------------------ */
    31      /**
    32       * Blocks until the thread pool is {@link LifeCycle#stop stopped}.
    33       */
    34      public void join() throws InterruptedException;
    35
    36      /* ------------------------------------------------------------ */
    37      /**
    38       * @return The total number of threads currently in the pool
    39       */
    40      public int getThreads();
    41
    42      /* ------------------------------------------------------------ */
    43      /**
    44       * @return The number of idle threads in the pool
    45       */
    46      public int getIdleThreads();
    47
    48      /* ------------------------------------------------------------ */
    49      /**
    50       * @return True if the pool is low on threads
    51       */
    52      public boolean isLowOnThreads();
    53  }